package <%= appPackage %>.viewmodel

import android.arch.lifecycle.ViewModel
import android.arch.lifecycle.ViewModelProvider
import javax.inject.Provider

/**
 * 页面描述：APPViewModelFactory  提供ViewModel 缓存的实例
 *
 * Created by ditclear on 2018/8/17.
 */
class APPViewModelFactory private constructor(): ViewModelProvider.Factory{

    private object Holder { val INSTANCE = APPViewModelFactory () }

    companion object {
        val instance: APPViewModelFactory by lazy { Holder.INSTANCE }
    }

    private val innerMap = hashMapOf<Class<out ViewModel>, @JvmSuppressWildcards Provider<ViewModel>>()

    //provides viewmodel instance
    override fun <T : ViewModel?> create(modelClass: Class<T>): T {
        val creator = innerMap[modelClass]?:innerMap.entries.firstOrNull{
            modelClass.isAssignableFrom(it.key)
        }?.value?:throw IllegalArgumentException("unknown model class $modelClass")
        try {
            @Suppress("UNCHECKED_CAST")
            return creator.get() as T
        } catch (e: Exception) {
            throw RuntimeException(e)
        }
    }

    //添加其它功能模块的viewmodel map
    fun plusMap(map:Map<Class<out ViewModel>, @JvmSuppressWildcards Provider<ViewModel>>){
        this.innerMap.putAll(map)
    }


}