package <%= appPackage %>

import android.app.Application
import android.arch.lifecycle.ViewModel
import <%= appPackage %>.di.component.DaggerAppComponent
import <%= appPackage %>.di.module.AppModule
import <%= appPackage %>.viewmodel.APPViewModelFactory
import javax.inject.Inject
import javax.inject.Provider

/**
 * 页面描述：App
 *
 * Created by ditclear on 2018/12/11.
 */
class App : Application() {

    @Inject
    lateinit var viewModelMap: Map<Class<out ViewModel>, @JvmSuppressWildcards Provider<ViewModel>>


    val appModule by lazy { AppModule(this) }

    override fun onCreate() {
        super.onCreate()

        DaggerAppComponent.builder().appModule(appModule).build().inject(this)

        APPViewModelFactory.instance.plusMap(viewModelMap)
    }
}